//+------------------------------------------------------------------+
//|                                      GetCriticalError_Unsafe.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2009, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"

input bool GetStop=false;// para obter um erro crtico
//+------------------------------------------------------------------+
//| Uma Classe simples                                               |
//+------------------------------------------------------------------+
class CHello
  {
private:
   string            m_message;
public:
                     CHello(){m_message="Iniciando...";}
   string            GetMessage(){return(m_message);}
  };
//---
CHello *pstatus;
//+------------------------------------------------------------------+
//| Imprime uma mensagem usando um mtodo de CHello do tipo objeto   |
//+------------------------------------------------------------------+
void UnsafePrintStatus(CHello &object)
  {
   DebugBreak();
   if(CheckPointer(GetPointer(object))==POINTER_INVALID)
      Print(__FUNCTION__," a varivel 'objeto' no foi inicializada!");
   else Print(object.GetMessage());
  }
//+------------------------------------------------------------------+
//| Funo de inicializao do Expert                                |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- chamando um mtodo para mostrar seu status
   if(GetStop)
      pstatus.GetMessage();
   else
      UnsafePrintStatus(pstatus);
//--- Imprimindo uma mensagem se o Expert Advisor foi inicializado corretamente
   Print(__FUNCTION__," A funo OnInit() foi concluda");
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Funo tick do Expert                                            |
//+------------------------------------------------------------------+
void OnTick()
  {
//---

  }
//+------------------------------------------------------------------+
